abstract class LifecycleMethod {
  const LifecycleMethod();
}

abstract class Disposable extends LifecycleMethod {
  const Disposable();

  void dispose();
}

abstract class Initializable extends LifecycleMethod {
  const Initializable();

  void initialize();
}

abstract class AsyncInitializable extends LifecycleMethod {
  const AsyncInitializable();

  Future<void> initializeAsync();
}
